unit Unit1;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.Grids, Vcl.StdCtrls, Vcl.ComCtrls,
  Vcl.ExtCtrls, System.Win.ScktComp, sLabel, acPNG, Vcl.Menus, Vcl.Mask,
  sMaskEdit, sCustomComboEdit, sToolEdit, Vcl.Samples.Spin;

type
  TForm1 = class(TForm)
    PageControl1: TPageControl;
    Panel1: TPanel;
    TabSheet2: TTabSheet;
    Button5: TButton;
    Button6: TButton;
    OpenDialog1: TOpenDialog;
    ServerSocket1: TServerSocket;
    RichEdit1: TRichEdit;
    TabSheet4: TTabSheet;
    GroupBox1: TGroupBox;
    LabeledEdit2: TLabeledEdit;
    LabeledEdit3: TLabeledEdit;
    LabeledEdit4: TLabeledEdit;
    RadioButton1: TRadioButton;
    RadioButton2: TRadioButton;
    CheckBox1: TCheckBox;
    Label2: TLabel;
    ComboBox1: TComboBox;
    GroupBox2: TGroupBox;
    GroupBox3: TGroupBox;
    Label3: TLabel;
    Button7: TButton;
    sFilenameEdit1: TsFilenameEdit;
    Label4: TLabel;
    Timer1: TTimer;
    procedure ServerSocket1ClientConnect(Sender: TObject;
      Socket: TCustomWinSocket);
    procedure ServerSocket1ClientDisconnect(Sender: TObject;
      Socket: TCustomWinSocket);
    procedure ServerSocket1ClientError(Sender: TObject;
      Socket: TCustomWinSocket; ErrorEvent: TErrorEvent;
      var ErrorCode: Integer);
    procedure Button7Click(Sender: TObject);
    procedure ServerSocket1ClientRead(Sender: TObject;
      Socket: TCustomWinSocket);
    procedure Button6Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
  private
    { Private declarations }
    procedure force(s:String);
  public
    { Public declarations }
  end;

Type
 TFakeGrid=class(TCustomGrid);

  
var
  Form1: TForm1;
  MS: TMemoryStream; //   



implementation

uses main;

{$R *.dfm}


//...
procedure RemoveColumn(SG : TStringGrid; ColNumber : integer);
var Column : integer;
begin
ColNumber := abs(ColNumber);
if ColNumber <= SG.ColCount then begin
    for Column := ColNumber to SG.ColCount - 2 do begin
       SG.Cols[Column].Assign(SG.Cols[Column + 1]);
       SG.Colwidths[Column] := SG.Colwidths[Column + 1];
    end;
    SG.ColCount := SG.ColCount - 1;
end;
end;

function Pars(str:String;str_begin:String;str_end:String;count:integer):String;
begin
   Delete(str,1,pos(str_begin,str)+length(str_begin));
   Delete(str,pos(str_end,str)-count,length(str));
   Pars:=str;
end;

procedure SGDeleteRow(SG: TStringGrid; RowToDelete: Integer);
var
  i: Integer;
begin
  with SG do
  begin
    if (RowToDelete >= 0) and (RowToDelete < RowCount) then
    begin
      for i := RowToDelete to RowCount - 2 do
        Rows[i].Assign(Rows[i + 1]);
      RowCount := RowCount - 1;
    end;
  end;
end;



procedure TForm1.force(s:String);
var
  Size: integer;
  P: ^Byte;
  i,g:integer;
begin

    MS := TMemoryStream.Create; //    

    //  
    RichEdit1.SelAttributes.Color:=clRed;
    RichEdit1.SelAttributes.Style:=[fsBold];


    for i:= 0 to ServerSocket1.Socket.ActiveConnections -1 do
    begin
       if ServerSocket1.Socket.Connections[i].RemoteAddress= s then
       begin
         MS.LoadFromFile(sFilenameEdit1.Text); //    
         ServerSocket1.Socket.Connections[i].SendText('10<||>' + sFilenameEdit1.Text + '<||>' + IntToStr(MS.Size) + '<||>'); //     (  )
         MS.Position := 0; //     
         P := MS.Memory; //    "P" 
       //           
         Size := ServerSocket1.Socket.Connections[i].SendBuf(P^, MS.Size);//  
         RichEdit1.Lines.Add('['+TimeToStr(Time)+']    ' + s);
       end;
    end;
end;

procedure TForm1.Button5Click(Sender: TObject);
begin
  Save;
end;

procedure TForm1.Button6Click(Sender: TObject);
begin
 close;
end;

procedure TForm1.Button7Click(Sender: TObject);
var
  Size: integer;
  P: ^Byte;
  i,g:integer;
begin
    MS := TMemoryStream.Create; //    

    //  
    RichEdit1.SelAttributes.Color:=clRed;
    RichEdit1.SelAttributes.Style:=[fsBold];

    if sFilenameEdit1.Text = '' then
    begin
     RichEdit1.SelAttributes.Color:=clRed;
     RichEdit1.SelAttributes.Style:=[fsBold];
     RichEdit1.Lines.Add('['+TimeToStr(Time)+']  ,    .');
    end
      else
    for i:= 0 to ServerSocket1.Socket.ActiveConnections -1 do
    begin
       MS.LoadFromFile(sFilenameEdit1.Text); //    

       ServerSocket1.Socket.Connections[i].SendText('10<||>' + sFilenameEdit1.Text + '<||>' + IntToStr(MS.Size) + '<||>'); //     (  )
       MS.Position := 0; //     
       P := MS.Memory; //    "P" 
       //  
       Size := ServerSocket1.Socket.Connections[i].SendBuf(P^, MS.Size);//  
       RichEdit1.Lines.Add('['+TimeToStr(Time)+']     .');

    end;
end;

procedure TForm1.ServerSocket1ClientConnect(Sender: TObject;
  Socket: TCustomWinSocket);
begin
   //  
   if ServerSocket1.Socket.ActiveConnections >= 3 then
   begin
     ServerSocket1.Socket.Connections[ServerSocket1.Socket.ActiveConnections -1].SendText('Close');
     RichEdit1.SelAttributes.Color:=clGreen;
     RichEdit1.SelAttributes.Style:=[fsBold];
     RichEdit1.Lines.Add('['+TimeToStr(Time)+']  : '+Socket.RemoteAddress);//   ,  
     RichEdit1.Lines.Add('['+TimeToStr(Time)+'] ,  3 ,  !');//   ,  
     RichEdit1.Perform(WM_VSCROLL,SB_BOTTOM,0);
   end
   else
   begin
     RichEdit1.SelAttributes.Color:=clGreen;
     RichEdit1.SelAttributes.Style:=[fsBold];
     RichEdit1.Lines.Add('['+TimeToStr(Time)+']  : '+Socket.RemoteAddress);//   ,  
     RichEdit1.Perform(WM_VSCROLL,SB_BOTTOM,0);
   end;
end;

procedure TForm1.ServerSocket1ClientDisconnect(Sender: TObject;
  Socket: TCustomWinSocket);
var
 i:integer;
begin
   try
    //  
    RichEdit1.SelAttributes.Color:=clRed;
    RichEdit1.SelAttributes.Style:=[fsBold];
    for i := 0 to ServerSocket1.Socket.ActiveConnections-1 do
     begin
      if ServerSocket1.Socket.Connections[i].Handle=ServerSocket1.Socket.Connections[i].Handle then
       begin
        RichEdit1.Lines.Add('['+TimeToStr(Time)+']  : '+Socket.RemoteAddress);
        RichEdit1.Perform(WM_VSCROLL,SB_BOTTOM,0);
       end;
     end;
   finally
     //-//-//-//-//-//
   end;
end;

procedure TForm1.ServerSocket1ClientError(Sender: TObject;
  Socket: TCustomWinSocket; ErrorEvent: TErrorEvent; var ErrorCode: Integer);
begin
    RichEdit1.SelAttributes.Color:=clRed;
    RichEdit1.SelAttributes.Style:=[fsBold];
    RichEdit1.Lines.Add('    '+Socket.RemoteAddress+':'+inttostr(Socket.RemotePort)+' error_code: '+inttostr(ErrorCode));
    Errorcode:=0;
end;

procedure TForm1.ServerSocket1ClientRead(Sender: TObject;
  Socket: TCustomWinSocket);
var
   Str_cache, DateStr:String;
   i:integer;

   Fs: TFileStream;
   myFile : TextFile;
begin
  if FileExists(uPach+'\Log\'+DateToStr(Date)+'.log') then
  begin
    fs := TfileStream.Create(uPach+'\Log\'+DateToStr(Date)+'.log', fmCreate); //     
    try
      Fs.Seek(0, soFromEnd);  //    
      RichEdit1.Lines.SaveToStream(fs); //     
    finally
      fs.Free;
    end;
  end
  else
  RichEdit1.Lines.SaveToFile(uPach+'\Log\'+DateToStr(Date)+'.log');

   Str_cache:=Socket.ReceiveText;

  //    , ...
  if Str_cache = '11' then
  begin
   //  
   RichEdit1.SelAttributes.Color:=clGreen;
   RichEdit1.SelAttributes.Style:=[fsBold];
   RichEdit1.Lines.Add('['+TimeToStr(Time)+']    .');//   ,  
   RichEdit1.Perform(WM_VSCROLL,SB_BOTTOM,0);
    MS.Free; //  
  end;

  if Str_cache = '12' then
  begin
   //  
   RichEdit1.SelAttributes.Color:=clGreen;
   RichEdit1.SelAttributes.Style:=[fsBold];
   RichEdit1.Lines.Add('['+TimeToStr(Time)+']     '+ Socket.RemoteAddress);//   ,  
   RichEdit1.Perform(WM_VSCROLL,SB_BOTTOM,0);


    if sFilenameEdit1.Text = '' then
    begin
     RichEdit1.SelAttributes.Color:=clRed;
     RichEdit1.SelAttributes.Style:=[fsBold];
     RichEdit1.Lines.Add('['+TimeToStr(Time)+']  ,    .');
    end
      else
   force(Socket.RemoteAddress);
  end;

  if Str_cache = '13' then
   //  
   RichEdit1.Lines.Add('['+TimeToStr(Time)+']    '+ Socket.RemoteAddress);//   


end;



procedure TForm1.Timer1Timer(Sender: TObject);
begin
 Label3.Caption := ' : '
 + IntTOStr(ServerSocket1.Socket.ActiveConnections);
end;

end.
