unit main;

interface

uses   Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.Grids, Vcl.StdCtrls, Vcl.ComCtrls,
  Vcl.ExtCtrls, Unit1, inifiles;

type
  TCommFortProcess = procedure(dwPluginID : DWORD; dID: DWORD; bOutBuffer : PAnsiChar; dwOutBufferSize : DWORD); stdcall;
  TCommFortGetData = function(dwPluginID : DWORD; dwID : DWORD; bInBuffer : PAnsiChar; dwInBufferSize : DWORD; bOutBuffer : PAnsiChar; dwOutBufferSize : DWORD): DWORD; stdcall;


function  PluginStart(dwThisPluginID : DWORD; func1 : TCommFortProcess; func2 : TCommFortGetData) : Integer; cdecl; stdcall;
procedure PluginStop(); cdecl; stdcall;
procedure PluginShowOptions(); cdecl; stdcall;
procedure PluginShowAbout(); cdecl; stdcall;
procedure PluginProcess(dwID : DWORD; bInBuffer : PAnsiChar; dwInBufferSize : DWORD); cdecl; stdcall;
function  PluginGetData(dwID : DWORD; bInBuffer : PAnsiChar;
            dwInBufferSize : DWORD; bOutBuffer : PAnsiChar; dwOutBufferSize : DWORD): DWORD; cdecl; stdcall;
function  PluginPremoderation(dwID : DWORD; wText : PWideChar; var dwTextLength : DWORD): Integer; cdecl; stdcall;

function  fReadInteger(bInBuffer : PAnsiChar; var iOffset : Integer): Integer;
function  fReadText(bInBuffer : PAnsiChar; var iOffset : Integer): WideString;
procedure fWriteInteger(var bOutBuffer : PAnsiChar; var iOffset  : Integer; iValue : Integer);
procedure fWriteText(bOutBuffer : PAnsiChar; var iOffset  : Integer; uValue : WideString);
function  fTextToAnsiString(uText : WideString) : AnsiString;
function  fIntegerToAnsiString(iValue : Integer) : AnsiString;
function Save:string;

var
  uPach:String;

exports PluginStart, PluginStop, PluginProcess, PluginGetData,
Save, PluginShowOptions, PluginShowAbout, PluginPremoderation;

implementation

var
  dwPluginID : DWORD;
  CommFortProcess : TCommFortProcess;
  CommFortGetData : TCommFortGetData;
    form1: TForm1;
   Ini: Tinifile;


function Save:string;
var
  Ini: Tinifile;
begin
  Ini:=TiniFile.Create(uPach+'IPTV_Plug.ini');
  Ini.WriteString('Setings','Andress m3u', Form1.sFilenameEdit1.text);
  Ini.WriteString('Setings','IP Andress', Form1.LabeledEdit4.text);
  Ini.WriteString('Setings','Bot Name', Form1.LabeledEdit2.text);
  Ini.WriteString('Setings','Bot Pass', Form1.LabeledEdit3.text);
  Ini.WriteBool('Setings','Setting', Form1.RadioButton2.Checked);
  Ini.WriteBool('Setings','Bot Pol', Form1.RadioButton1.Checked);
  Ini.WriteBool('Setings','Bot OFF', Form1.CheckBox1.Checked);

  Ini.Free;

end;

function open:string;
var
 ini: TIniFile;
 myFile : TextFile;
begin
  if DirectoryExists(uPach)then else
   CreateDir(uPach);

  if DirectoryExists(uPach+'\Log')then else
   CreateDir(uPach+'\Log');


  Ini:=TiniFile.Create(uPach+'IPTV_Plug.ini');
  Form1.sFilenameEdit1.text:=Ini.ReadString('Setings', 'Andress m3u','');
  Form1.LabeledEdit4.text:=Ini.ReadString('Setings', 'IP Andress','192.168.1.1');
  Form1.LabeledEdit2.text:=Ini.ReadString('Setings', 'Bot Name','IP-TV');
  Form1.LabeledEdit3.text:=Ini.ReadString('Setings', 'Bot Pass','123');
  Form1.RadioButton2.Checked:=Ini.ReadBool('Setings', 'Setting', True);
  Form1.RadioButton1.Checked:=Ini.ReadBool('Setings', 'Bot Pol', False);
  Form1.CheckBox1.Checked:=Ini.ReadBool('Setings', 'Bot OFF', True);

  Ini.Free;

end;

//---------------------------------------------------------------------------
function fReadInteger(bInBuffer : PAnsiChar; var iOffset : Integer): Integer; //       
begin
	CopyMemory(@Result, bInBuffer + iOffSet, 4);
	iOffset := iOffset + 4;
end;

function fReadText(bInBuffer : PAnsiChar; var iOffset : Integer): WideString; //       
 var iLength : Integer;
begin
	CopyMemory(@iLength, bInBuffer + iOffSet, 4);
	iOffset := iOffset + 4;
	SetLength(Result, iLength);
	CopyMemory(@Result[1], bInBuffer + iOffSet, iLength * 2);
	iOffset := iOffset + iLength * 2;
end;

//---------------------------------------------------------------------------
procedure fWriteInteger(var bOutBuffer : PAnsiChar; var iOffset  : Integer; iValue : Integer); //       
begin
	CopyMemory(bOutBuffer + iOffSet, @iValue, 4);
	iOffset := iOffset + 4;
end;
//---------------------------------------------------------------------------
procedure fWriteText(bOutBuffer : PAnsiChar; var iOffset  : Integer; uValue : WideString); //       
	var iLength : Integer;
begin
	iLength := Length(uValue);
	CopyMemory(bOutBuffer + iOffset, @iLength, 4);
	iOffset := iOffset + 4;

	CopyMemory(bOutBuffer + iOffSet, @uValue[1], iLength * 2);
	iOffset := iOffset + iLength * 2;
end;

//---------------------------------------------------------------------------
function fTextToAnsiString(uText : WideString) : AnsiString; //      
	var iLength : Integer;
begin
	//    ,
	//    ,
	//        
	iLength := Length(uText);

	SetLength(Result, 4 + iLength * 2);

	CopyMemory(@Result[1], @iLength, 4);
	CopyMemory(PAnsiChar(Result) + 4, @uText[1], iLength * 2);
end;
//---------------------------------------------------------------------------
function fIntegerToAnsiString(iValue : Integer) : AnsiString; //      
begin
	//    ,
	//    ,
	//        

	SetLength(Result, 4);
	CopyMemory(@Result[1], @iValue, 4);
end;
//---------------------------------------------------------------------------
function PluginStart(dwThisPluginID : DWORD; func1 : TCommFortProcess; func2 : TCommFortGetData) : Integer;
var aDataToSend, aData : AnsiString;
    iSize, iReadOffset, iCon : Integer;
    uVersion : WideString;
begin
	dwPluginID := dwThisPluginID;
	//     
	//   ,  
	//      
	CommFortProcess := func1;
        //   ,
	//      

	CommFortGetData := func2;
        //   ,
	//         

	//     (  ):
	iSize := CommFortGetData(dwPluginID, 2010, nil, 0, nil, 0); //  
	SetLength(aData, iSize);

	CommFortGetData(dwPluginID, 2010, PAnsiChar(aData), iSize, nil, 0);// 
	iReadOffset := 0;

  uPach := fReadText(PAnsiChar(aData), iReadOffset)+'IPTV Control\';
  form1 := TForm1.Create(Application);

  open;


  if Form1.CheckBox1.Checked = true then
  begin
   if Form1.RadioButton1.Checked = True then
    iCon := 0 else
    iCon := 1;

	//  
  	aDataToSend := fTextToAnsiString(Form1.LabeledEdit2.Text)+  //
	 fTextToAnsiString(Form1.LabeledEdit4.Text)+ //IP-
	 fIntegerToAnsiString(0)+  //   
	 fTextToAnsiString(Form1.LabeledEdit3.Text)+   //
	 fIntegerToAnsiString(iCon); // 

	 CommFortProcess(dwPluginID, 1001, PAnsiChar(aDataToSend), Length(aDataToSend));
  end;


	// :
	//TRUE -   
	//FALSE -  
	Result := Integer(TRUE);
end;
//---------------------------------------------------------------------------
procedure PluginStop();
begin
	//      
end;
//---------------------------------------------------------------------------
procedure PluginProcess(dwID : DWORD; bInBuffer : PAnsiChar; dwInBufferSize : DWORD);
var iReadOffset, iSenderIcon, iMessageMode : Integer;
    aDataToSend : AnsiString;
    uVirtualUserLogin, uSenderLogin, uSenderIP, uChannel, uText : WideString;

begin
	//  
	//:
	//dwID -  
	//bInBuffer -   
	//dwInBufferSize -    
	iReadOffset := 0;

end;
//---------------------------------------------------------------------------
function PluginGetData(dwID : DWORD; bInBuffer : PAnsiChar; dwInBufferSize : DWORD; bOutBuffer : PAnsiChar; dwOutBufferSize : DWORD): DWORD;
var iWriteOffset, iSize : Integer; //       
    uName : WideString;
begin

      //   
	iWriteOffset := 0;

	//  dwOutBufferSize       ,   

	if (dwID = 2800) then // 
	begin
		if (dwOutBufferSize = 0) then
			Result := 4 //   ,    
		else
		begin
			fWriteInteger(bOutBuffer, iWriteOffset, 1); //    
			Result := 4;//    
		end;
	end
	else
	if (dwID = 2810) then //  (  )
	begin
		uName := 'IPTV Plugin Control';// 
		iSize := Length(uName) * 2 + 4;

		if (dwOutBufferSize = 0) then
			Result := iSize //   ,    
		else
		begin
			fWriteText(bOutBuffer, iWriteOffset, uName);
			Result := iSize;//    
		end;
	end
	else
		Result := 0;//  -   
end;
//---------------------------------------------------------------------------
function PluginPremoderation(dwID : DWORD; wText : PWideChar; var dwTextLength : DWORD):  Integer;
var uCheck, uRet : WideString;
begin
	// 
        //     ,      ,    

	//!    40000 .       .
	if (dwID = 1000) then//     
	begin
		uCheck := '    ';

		// Delphi  2009       //if  ( StrComp(PAnsiChar(wText), PAnsiChar(uCheck)) = 0) then
	 	if ( StrComp(wText, PWideChar(uCheck)) = 0) then
		begin
			uRet := '    : ';
			CopyMemory(wText, @uRet[1], Length(uRet) * 2);
			dwTextLength := Length(uRet);//  
			Result := Integer(TRUE);//TRUE     
		end
		else
			Result := Integer(FALSE);
	end
	else
		Result := Integer(FALSE);//  FALSE       
end;

//---------------------------------------------------------------------------
procedure PluginShowOptions();
begin
   Form1.Show;
end;

//---------------------------------------------------------------------------
procedure PluginShowAbout();
begin
	//      " "   

end;

end.
